Package ch.qos.logback.classic.sift

# Class ContextBasedDiscriminator

java.lang.Object
ch.qos.logback.core.spi.ContextAwareBase
ch.qos.logback.core.sift.AbstractDiscriminator<ILoggingEvent>
ch.qos.logback.classic.sift.ContextBasedDiscriminator

All Implemented Interfaces:
  `Discriminator<ILoggingEvent>`, `ContextAware`, `LifeCycle`

public class ContextBasedDiscriminator extends AbstractDiscriminator<ILoggingEvent>
This discriminator returns the value context to which this event is attached to. If the said value is null, then a default value is returned.

Both Key and the DefaultValue are user specified properties.

Author:
  Ceki Gülcü

## Field Summary

### Fields inherited from class ch.qos.logback.core.sift.AbstractDiscriminator

`started`

### Fields inherited from class ch.qos.logback.core.spi.ContextAwareBase

`context`

## Constructor Summary

Constructors
Constructor
Description
`ContextBasedDiscriminator()`

## Method Summary

Modifier and Type
Method
Description
`String`
`getDefaultValue()`
`String`
`getDiscriminatingValue(ILoggingEvent event)`
Return the name of the current context name as found in the logging event.
`String`
`getKey()`
The key or variable name under which the discriminating value should be exported into the host environment.
`void`
`setDefaultValue(String defaultValue)`
The default context name in case the context name is not set for the current logging event.
`void`
`setKey(String key)`

### Methods inherited from class ch.qos.logback.core.sift.AbstractDiscriminator

`isStarted, start, stop`

### Methods inherited from class ch.qos.logback.core.spi.ContextAwareBase

`addError, addError, addInfo, addInfo, addStatus, addWarn, addWarn, getContext, getDeclaredOrigin, getStatusManager, setContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ContextBasedDiscriminator

public ContextBasedDiscriminator()

## Method Details

### getDiscriminatingValue

public String getDiscriminatingValue(ILoggingEvent event)
Return the name of the current context name as found in the logging event.

Returns:

### getKey

public String getKey()
Description copied from interface: `Discriminator`
The key or variable name under which the discriminating value should be exported into the host environment.

Returns:

### setKey

public void setKey(String key)

### getDefaultValue

public String getDefaultValue()

Returns:
See Also:
  - `setDefaultValue(String)`

### setDefaultValue

public void setDefaultValue(String defaultValue)
The default context name in case the context name is not set for the current logging event.

Parameters:
  `defaultValue` -